package com.charego.freecellfx;

import com.charego.freecellfx.model.Game;
import com.charego.freecellfx.view.GameCanvas;
import com.charego.freecellfx.view.GameMenuBar;
import javafx.application.Application;
import javafx.application.Platform;
import javafx.scene.Scene;
import javafx.scene.image.Image;
import javafx.scene.layout.*;
import javafx.stage.Stage;

public class FreeCellApplication extends Application {

    public static void main(String[] args) {
        launch(FreeCellApplication.class, args);
    }

    @Override
    public void start(Stage stage) throws Exception {
        VBox root = new VBox();
        root.setBackground(new Background(new BackgroundImage(new Image(
                "/deck/FELT.jpg"), BackgroundRepeat.NO_REPEAT,
                BackgroundRepeat.NO_REPEAT, BackgroundPosition.CENTER,
                BackgroundSize.DEFAULT)));

        Game game = new Game();
        GameMenuBar menuBar = new GameMenuBar();
        GameCanvas canvas = new GameCanvas(game, 731, 600);
        menuBar.setNewGameAction(canvas.getNewGameAction());
        menuBar.setUndoAction(canvas.getUndoAction());
        menuBar.setRedoAction(canvas.getRedoAction());
        menuBar.setExitAction(e -> Platform.exit());
        root.getChildren().addAll(menuBar, canvas);
        Scene scene = new Scene(root);

        stage.setTitle("FreeCell");
        stage.setScene(scene);
        stage.setResizable(false);
        stage.show();
    }

}
